
#ifndef KWLANMAINWIN_H
#define KWLANMAINWIN_H

#include "kwlan.h"
#include "configuration.h"
#include "wpa_ctrl.h"
#include "kwlantraywin.h"
#include "wpamsg.h"
#include <kapplication.h>
#include <qstringlist.h>
#include <qsocketnotifier.h>

class KScanDlg;
class KEventHistoryDlg;
class KUserDataRequestDlg;
class KTempFile;

class KWlanMainWin : public Kwlan
{
  Q_OBJECT

    public:
    KWlanMainWin(QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
    ~KWlanMainWin();
    /*$PUBLIC_FUNCTIONS$*/
    
    
    public slots:
    /*$PUBLIC_SLOTS$*/
        virtual void          cbInterfaceChanged(const QString & interface);
        virtual int           init(QString interface);
        virtual void          editSettings();
        virtual void          releaseIpAddress();
        virtual void          receiveMsgs();
        virtual void          processCtrlReq( const char * request );
        virtual void          processMessage(char *message);
        virtual void          toolsLogViewer();
        virtual void          scan();
        virtual void          fileStopWpaSupplicant();
        virtual void          getIpAddress();
        virtual void          fileStartWpaSupplicant();
        virtual void          triggerUpdate();
        virtual int           openControlConnection(const char *interfaceName);
        virtual int           ctrlRequest(const char *command, char *bur, size_t *buflen);
        virtual void          checkConnection();
        virtual void          updateNetworks();
        virtual void          updateStatus();
        virtual void          profileDelete();
        virtual void          profileModify();
        virtual void          profileNew();
        virtual void          profileActivate();
        virtual void          helpAbout();
        virtual void          fileExit();
        virtual void          profileSelect(QString profile);
    
    signals:
        void statusChanged(bool connected);
        void ipChanged(const QString &ipaddress);
        void interfaceChanged(const QString &interface);
        
    protected:
    /*$PROTECTED_FUNCTIONS$*/
    
    protected slots:
    /*$PROTECTED_SLOTS$*/
        
    private:
    
        bool getRootPassword();
        QStringList m_wlanInterfaces;
        //EventHistory *m_events;
        //ScanResults *m_scanResult;
        //UserDataRequest * m_userDataRequest;
        char *m_controlInterface;
        char *m_controlInterfaceDir;
        wpa_ctrl *m_controlConnection,*m_monitorConnection;
        QSocketNotifier *m_messageNotifier;
        bool m_networkChange;
        bool m_startDhclient;
        bool m_associated;
        bool m_IpAddress;
        bool m_wpaStarted;
        bool m_useDhclient;
        bool m_useDhcpcd;
        bool m_dhcpEnabled;
        bool m_wpaWarned; // User has been warned in case of failure to connect to wpa_supplicant
        QString m_ssid;
        QString m_staticIpAddress,  m_staticGateway, m_staticNetmask;
        QString m_staticDns1, m_staticDns2, m_domain;
        bool m_dontOverrideDns, m_dontOverrideGw;
        QString m_dhclientPath, m_dhcpcdPath, m_wpaPath; //Path to external applications that are frequently used
        QTimer *m_timer;
        KWlanTrayWin *m_tray;
        KScanDlg *m_scanDlg;
        KEventHistoryDlg *m_eventHistory;
        WpaMsgList m_messages;
        KUserDataRequestDlg *m_userDataRequest;
        KTempFile *resolvconf;
    
    private slots:
        void cleanTemporaryFiles();

};

#endif





















