#ifndef _KWLANKICKER_H_
#define _KWLANKICKER_H_


#include <sys/types.h>
#include <ksystemtray.h>
#include <qtooltip.h>
#include <qstring.h>
#include <qptrlist.h>
#include <kpopupmenu.h>
#include <qtimer.h>

class QWidget;
class KAction;


// Tooltip class to show extended link information - "KGet approach"

class KWlanToolTip : public QToolTip {

    public:
     	KWlanToolTip(QWidget *parent);
    virtual ~KWlanToolTip();
	
    protected:
       void maybeTip(const QPoint &);
};


// Class to show status in systray

class KWlanTrayWin : public KSystemTray
{
    Q_OBJECT
    public:
        KWlanTrayWin(QWidget *parent=0, const char *name=0);
        virtual ~KWlanTrayWin();
        void contextMenuAboutToShow ( KPopupMenu * );
        bool isConnected() const;
        const QString & getInterface() const;
        const QString & getIpAddress() const;
        void clearProfiles();
        void insertProfile(QString *profile);
    signals:
        void clicked();
        void aboutSelected();
        void profileChanged(QString profile);
    public slots:
        void updateIcon();
        void setInterface(const QString &ifname);
        void setIpAddress(const QString &ipaddress);
        void setConnectionStatus(bool status);

    protected:
        //void mouseReleaseEvent( QMouseEvent * );
        QString m_ifname;
        bool m_connected;
        QString m_ipaddress;
        KAction *m_quit, *m_about;
        KWlanToolTip *m_tooltip;
        QTimer *m_timer;
    private slots:
        void selectProfile(int id);
    private:
        QPtrList<QString> m_profiles;
        KPopupMenu *m_profileMenu;
};


#endif
